{ config, lib, pkgs, ... }:

{
  #boot.kernelPackages = pkgs.recurseIntoAttrs (pkgs.linuxPackagesFor
  #  (pkgs.linux_latest.override {
  #  kernelPatches = pkgs.linux_latest.kernelPatches ++ [
  #    {
  #      name = "bfq1";
  #      patch = pkgs.fetchurl {
  #        url = "ftp://teambelgium.net/bfq/patches/4.5.0-v7r11/0001-block-cgroups-kconfig-build-bits-for-BFQ-v7r11-4.5.0.patch";
  #        sha256 = "1j6h831kj32c9slzm4vhjvd8m17gbwh713kcpc54z9i02fwyq6ax";
  #      };
  #    }
  #    {
  #      name = "bfq2";
  #      patch = pkgs.fetchurl {
  #        url = "ftp://teambelgium.net/bfq/patches/4.5.0-v7r11/0002-block-introduce-the-BFQ-v7r11-I-O-sched-for-4.5.0.patch";
  #        sha256 = "1q8nf7fcp72s2xz2pfl22sv4w5fm4hzgciljrkd3g7gj5xvi27lw";
  #      };
  #    }
  #    {
  #      name = "bfq3";
  #      patch = pkgs.fetchurl {
  #        url = "ftp://teambelgium.net/bfq/patches/4.5.0-v7r11/0003-block-bfq-add-Early-Queue-Merge-EQM-to-BFQ-v7r11-for.patch";
  #        sha256 = "1q2j7g3cfwi52psxgwa06hadl6c2fh87ckm07pyaj35n6524gjg0";
  #      };
  #    }
  #  ];
  #  extraConfig  = ''
  #    BFQ_GROUP_IOSCHED y
  #    IOSCHED_BFQ y
  #    DEFAULT_BFQ y
  #  '';
  #  })
  #  pkgs.linuxPackages_latest
  #);

  boot.kernelPackages = pkgs.linuxPackages_4_6;

  # Bootloader, initrd and Kernel
  boot.loader.grub.enable = true;
  boot.loader.grub.enableCryptodisk = true;
  boot.loader.grub.version = 2;

  # Workaround for nm-pptp
  boot.kernelModules = [ 
      "nf_conntrack_proto_gre"
      "nf_conntrack_pptp"
  ];

  boot.tmpOnTmpfs = true;
}
